unit AppGlobal_U;
// Description: Application-wide Global Declarations
// By Sarah Dean
// Email: sdean12@softhome.net
// WWW:   http://www.SDean12.org/
//
// -----------------------------------------------------------------------------
//


interface

uses
  dialogs,
  STUIniFile_U,
  WinInfo,
  AppGlobalConsts_U;

procedure ErrorMessage(errorMsg : string);
function  IsADir(name: string): boolean;
procedure LaunchExplorer(driveLetter: string);

var
  STU_INI_FILE: TSTUIniFile;
  WindowsInfo: TWindowsInfo;


implementation

{$IFDEF LINUX}
This software is only intended for use under MS Windows
{$ENDIF}
{$WARN UNIT_PLATFORM OFF}  // Useless warning about platform - we're already
                           // protecting against that!
{$WARN SYMBOL_PLATFORM OFF}  // Useless warning about platform - we're already
                             // protecting against that!

uses SysUtils,
     FileCtrl,
     Windows; // needed for TWIN32FindData in ConvertSFNPartToLFN

procedure ErrorMessage(errorMsg : string);
begin
  messageDlg(errorMsg, mtError, [mbOK], 0);
end;


function IsADir(name: string): boolean;
var
  fileAttributes : integer;
begin
  fileAttributes := FileGetAttr(name);
  Result := not((fileAttributes AND faDirectory)=0);

end;

procedure LaunchExplorer(driveLetter: string);
var
  explorerCommandLine: string;
begin
  if driveLetter<>'' then
    begin
    explorerCommandLine := 'explorer ' + driveLetter + ':\';

    if (WinExec(PChar(explorerCommandLine), SW_RESTORE))<31 then
      begin
      ErrorMessage('Error running explorer');
      end;

    end;
end;


// -----------------------------------------------------------------------------

// -----------------------------------------------------------------------------
// -----------------------------------------------------------------------------
{$WARN SYMBOL_PLATFORM ON}
{$WARN UNIT_PLATFORM ON}
// -----------------------------------------------------------------------------

END.

