unit DismountVolumes_U;
// Description: Dismount ScramDisk Volumes
// By Sarah Dean
// Email: sdean12@softhome.net
// WWW:   http://www.SDean12.org/
//
// -----------------------------------------------------------------------------
//


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,
  OTFEUnified_U;

type
  TDismountVolumes_F = class(TForm)
    lbDrivesMounted: TListBox;
    pbDismount: TButton;
    pbCancel: TButton;
    Label1: TLabel;
    ckEmergencyDismount: TCheckBox;
    pbSelectAll: TButton;
    procedure FormShow(Sender: TObject);
    procedure pbDismountClick(Sender: TObject);
    procedure pbSelectAllClick(Sender: TObject);
  private
    { Private declarations }
  public
    OTFEUnified: TOTFEUnified;
  end;


implementation

{$R *.DFM}

uses AppGlobal_U, AppGlobalConsts_U,
     SDUGeneral;


procedure TDismountVolumes_F.FormShow(Sender: TObject);
var
  i : integer;
  mtdDrvs: string;
begin
  lbDrivesMounted.clear;

  mtdDrvs:= OTFEUnified.DrivesMounted();
  for i:=1 to length(mtdDrvs) do
    begin
    lbDrivesMounted.items.add(mtdDrvs[i]+':  '+OTFEUnified.GetVolFileForDrive(mtdDrvs[i]));
    end;

  lbDrivesMounted.itemindex := 0;
  if lbDrivesMounted.items.count=1 then
    begin
    lbDrivesMounted.selected[0] := TRUE;
    end;

end;


procedure TDismountVolumes_F.pbDismountClick(Sender: TObject);
var
  i: integer;
  msg: string;
begin
  for i:=0 to (lbDrivesMounted.items.count-1) do
    begin
    if lbDrivesMounted.selected[i] then
      begin
      if not(OTFEUnified.Dismount((lbDrivesMounted.items[i])[1], ckEmergencyDismount.checked)) then
        begin
        msg := 'Dismount of drive '+(lbDrivesMounted.items[i])[1]+' failed'+
               CRLF+
               CRLF+
               'Please ensure that you have no files open on this drive and try again';
        if not(ckEmergencyDismount.checked) then
          begin
          msg := msg +
                 CRLF+
                 CRLF+
                 'If dismounting still fails, you could try an emergency dismount';
          end;
        showmessage(msg);
        end;
      end;
    end;

  ModalResult := mrOK;
end;

procedure TDismountVolumes_F.pbSelectAllClick(Sender: TObject);
var
  i: integer;
begin
  for i:=0 to (lbDrivesMounted.items.count-1) do
    begin
    lbDrivesMounted.selected[i] := TRUE;
    end;

end;

END.


