unit IconChooser_U;
// Description: Icon Chooser Dialog
// By Sarah Dean
// Email: sdean12@softhome.net
// WWW:   http://www.SDean12.org/
//
// -----------------------------------------------------------------------------
//


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls;

type
  TIconChooser_F = class(TForm)
    lstSelection: TListView;
    pbOK: TButton;
    pbCancel: TButton;
    procedure lstSelectionDblClick(Sender: TObject);
  private
    procedure SetSelected(itemIdx: integer);
    function  GetSelected(): integer;
  public
    procedure SetIcons(iconList: TImageList);
    procedure AddItem(caption: string; imageIdx: integer);
  published
    property Selected: integer read GetSelected write SetSelected;
  end;

implementation

{$R *.DFM}

procedure TIconChooser_F.SetIcons(iconList: TImageList);
begin
  lstSelection.LargeImages := iconList;
end;

procedure TIconChooser_F.AddItem(caption: string; imageIdx: integer);
var
  item: TListItem;
begin
  item := lstSelection.Items.Add;
  item.caption := caption;
  item.ImageIndex := imageIdx;

end;

procedure TIconChooser_F.SetSelected(itemIdx: integer);
begin
  lstSelection.selected := lstSelection.items[itemIdx];

end;

function TIconChooser_F.GetSelected(): integer;
begin
  Result := lstSelection.selected.index;

end;

procedure TIconChooser_F.lstSelectionDblClick(Sender: TObject);
begin
  ModalResult := mrOK;
  
end;

END.
