unit OTFVolumeDetailsTrueCrypt_U;
// Description:
// By Sarah Dean
// Email: sdean12@softhome.net
// WWW:   http://www.SDean12.org/
//
// -----------------------------------------------------------------------------
//


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls,
  OTFVolumeDetails_U;

type
  TOTFVolumeDetailsTrueCrypt_F = class(TOTFVolumeDetails_F)
    gbVolInfo: TGroupBox;
    Label9304: TLabel;
    Label9300: TLabel;
    Label9302: TLabel;
    Label9305: TLabel;
    Label9303: TLabel;
    edFilename: TEdit;
    edDriveMountedAs: TEdit;
    edReadOnly: TEdit;
    edCipher: TEdit;
    edVolumeLocation: TEdit;
    Label2020: TLabel;
    Label9301: TLabel;
    edVolLabel: TEdit;
    Label9306: TLabel;
    Label9307: TLabel;
    Label9308: TLabel;
    Label9309: TLabel;
    edPKCS5: TEdit;
    edPKCS5Iterations: TEdit;
    edDateVolumeCreated: TEdit;
    edDatePasswordChanged: TEdit;
    Label9310: TLabel;
    edCipherMode: TEdit;
    Label9311: TLabel;
    edVolumeType: TEdit;
  private
    { Private declarations }
  public
    constructor Create(AOwner: TComponent); override;
    function  DisplayInfoForDrive(driveLetter: char): boolean; override;
  end;

implementation

{$R *.DFM}

uses
  OTFETrueCrypt_U,
  OTFETrueCryptStructures_U,
  OTFEUnified_U,
  SDUGeneral;

constructor TOTFVolumeDetailsTrueCrypt_F.Create(AOwner: TComponent);
begin
  inherited;

  OTFSystem:= otfesTrueCrypt;

end;

function TOTFVolumeDetailsTrueCrypt_F.DisplayInfoForDrive(driveLetter: char): boolean;
var
  info: TOTFETrueCryptVolumeInfo;
  retVal: boolean;
begin
  retVal := FALSE;

  edDriveMountedAs.text := driveLetter+':';
  edVolLabel.text := SDUVolumeID(driveLetter);

  edFilename.text            := '<Unknown>';
  edCipher.text              := '<Unknown>';
  edVolumeLocation.text      := '<Unknown>';
  edVolumeType.text          := '<Unknown>';
  edReadOnly.text            := '<Unknown>';
  edPKCS5.text               := '<Unknown>';
  edPKCS5Iterations.text     := '<Unknown>';
  edDateVolumeCreated.text   := '<Unknown>';
  edDatePasswordChanged.text := '<Unknown>';

  if TOTFETrueCrypt(OTFComponent).GetDriveInfo(driveLetter, @info) then
    begin
    edFilename.text := info.volumeFilename;
    edCipher.text := info.cipherNames;
    edCipherMode.text := info.cipherModeName;
    edVolumeLocation.text := info.volumeLocationName;
    
    edVolumeType.text := 'Normal';
    if (info.hidden) then
      begin
      edVolumeType.text := 'Hidden';
      end;

    if info.readonly then
      begin
      edReadOnly.text := 'Readonly';
      end
    else
      begin
      edReadOnly.text := 'Read/Write';
      end;

    edPKCS5.text := info.pkcs5TypeName;
    edPKCS5Iterations.text := inttostr(info.pkcs5Iterations);
    edDateVolumeCreated.text := DateTimeToStr(info.volumeCreated);
    edDatePasswordChanged.text := DateTimeToStr(info.passwordChanged);

    retVal:= TRUE;
    end;

  Result := retVal;
end;

END.

