unit OptionsOTFSystems_U;
// Description: Options Dialog
// By Sarah Dean
// Email: sdean12@softhome.net
// WWW:   http://www.SDean12.org/
//
// -----------------------------------------------------------------------------
//


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, Spin,
  Menus, // Menus needed for ShortCutToText and TextToShortCut
  OTFEUnified_U;

type
  TOptionsOTFSystems_F = class(TForm)
    pbOK: TButton;
    pbCancel: TButton;
    pbApply: TButton;
    pcOptions: TPageControl;
    tsGeneral: TTabSheet;
    tsHotKeys: TTabSheet;
    OpenDialog: TOpenDialog;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    lblDismountBrutal: TLabel;
    lblDismount: TLabel;
    hkDismount: THotKey;
    hkDismountBrutal: THotKey;
    ckEnableDismount: TCheckBox;
    ckEnableDismountBrutal: TCheckBox;
    tsTimeouts: TTabSheet;
    Label7: TLabel;
    ckEnableTimeout: TCheckBox;
    Label8: TLabel;
    seTimout: TSpinEdit;
    gbActionOnTimeout: TRadioGroup;
    GroupBox3: TGroupBox;
    ckMountVolStart: TCheckBox;
    ckAlwaysUnmounedIcon: TCheckBox;
    Label3: TLabel;
    ckExploreAfterMount: TCheckBox;
    tsSpecial: TTabSheet;
    GroupBox5: TGroupBox;
    pbForceClear: TButton;
    pbEnterPassword: TButton;
    Label4: TLabel;
    Label10: TLabel;
    ckDisplayHidePasswordsCk: TCheckBox;
    tsOTFBestCrypt: TTabSheet;
    tsOTFEE4M: TTabSheet;
    tsOTFPGPDisk: TTabSheet;
    tsOTFEScramDisk: TTabSheet;
    GroupBox4: TGroupBox;
    Label2: TLabel;
    Label1: TLabel;
    Label9: TLabel;
    edScramdiskExeLocation: TEdit;
    pbScramDiskBrowse: TButton;
    GroupBox6: TGroupBox;
    Label5: TLabel;
    Label6: TLabel;
    edDefaultDir: TEdit;
    pbDefDirBrowse: TButton;
    cbActionOnExit: TComboBox;
    cbActionOnDblClk: TComboBox;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label15: TLabel;
    tsOTFESupport: TTabSheet;
    GroupBox7: TGroupBox;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    lblScramDiskVolumes: TLabel;
    pnlVersions: TPanel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    cbScramDiskVolumes: TComboBox;
    pnlEnableSystem: TPanel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    Label19: TLabel;
    GroupBox8: TGroupBox;
    ckScramDiskUseRedScreen: TCheckBox;
    ckMountPartStart: TCheckBox;
    Label27: TLabel;
    Label26: TLabel;
    Label25: TLabel;
    Label29: TLabel;
    GroupBox9: TGroupBox;
    Label20: TLabel;
    hkVolInfo: THotKey;
    ckEnableVolInfo: TCheckBox;
    GroupBox10: TGroupBox;
    Label14: TLabel;
    Label28: TLabel;
    Label30: TLabel;
    edE4MExeLocation: TEdit;
    pbE4MBrowse: TButton;
    cbDefaultSystem: TComboBox;
    lblDefaultSystem: TLabel;
    rgE4MMountDeviceDlgStyle: TRadioGroup;
    Label31: TLabel;
    cbScramDiskPreferredDrive: TComboBox;
    Label32: TLabel;
    cbDefaultFilter: TComboBox;
    TabSheet1: TTabSheet;
    GroupBox11: TGroupBox;
    edPostMountExe: TEdit;
    Label33: TLabel;
    pbPrePostBrowse1: TButton;
    pbPrePostBrowse2: TButton;
    edPreDismountExe: TEdit;
    Label34: TLabel;
    pbPrePostBrowse3: TButton;
    edPostDismountExe: TEdit;
    Label35: TLabel;
    Label36: TLabel;
    ckPrePostExeWarn: TCheckBox;
    ckDisableScramDiskSVLProtection: TCheckBox;
    ckConfirmOnDismount: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    Label37: TLabel;
    Label38: TLabel;
    tsOTFETrueCrypt: TTabSheet;
    gbTrueCryptVersionHint: TGroupBox;
    cbTrueCryptVersionHint: TComboBox;
    Label40: TLabel;
    Label39: TLabel;
    Label41: TLabel;
    Label42: TLabel;
    Label43: TLabel;
    CheckBox7: TCheckBox;
    Label44: TLabel;
    tsOTFECrossCrypt: TTabSheet;
    tsOTFEFreeOTFE: TTabSheet;
    GroupBox12: TGroupBox;
    Label45: TLabel;
    Label46: TLabel;
    Label47: TLabel;
    edCrossCryptExeLocation: TEdit;
    pbCrossCryptBrowse: TButton;
    GroupBox13: TGroupBox;
    Label48: TLabel;
    Label49: TLabel;
    Label50: TLabel;
    edFreeOTFEExeLocation: TEdit;
    pbFreeOTFEBrowse: TButton;
    rgTrueCryptMountDeviceDlgStyle: TRadioGroup;
    procedure pbScramDiskBrowseClick(Sender: TObject);
    procedure pbOKClick(Sender: TObject);
    procedure pbApplyClick(Sender: TObject);
    procedure SetApplyButton(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure pbForceClearClick(Sender: TObject);
    procedure pbEnterPasswordClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure pbDefDirBrowseClick(Sender: TObject);
    procedure SystemEnabledCheckBoxClick(Sender: TObject);
    procedure cbDefaultSystemChange(Sender: TObject);
    procedure pbE4MBrowseClick(Sender: TObject);
    procedure pbPrePostBrowse1Click(Sender: TObject);
    procedure pbPrePostBrowse2Click(Sender: TObject);
    procedure pbPrePostBrowse3Click(Sender: TObject);
    procedure pbCrossCryptBrowseClick(Sender: TObject);
    procedure pbFreeOTFEBrowseClick(Sender: TObject);
  private
    newDefaultOTFSystem: TOTFESystem;
    procedure LoadINIValues();
    procedure EnableDisableAllControls();
    procedure EnableDisableScramDiskVolumes();
    procedure EnableDisableDefaultSystem();
    procedure CheckOTFComponents();
    procedure CheckDefaultSystemOK();
    procedure SetupOTFSystemDispNameCaptions();
  public
    OTFEUnified: TOTFEUnified;
  end;

implementation

{$R *.DFM}

{$IFDEF LINUX}
This software is only intended for use under MS Windows
{$ENDIF}
{$WARN UNIT_PLATFORM OFF}  // Useless warning about platform - we're already
                           // protecting against that!

uses
  AppGlobal_U,
  AppGlobalConsts_U,
  STUIniFile_U,
  FileCtrl,
  SDUGeneral,
  OTFEScramDisk_U,
  OTFEE4M_U,
  OTFETrueCryptStructures_U;

const
  TRUECRYPT_VERSIONHINT_AUTODETECT = 'Autodetect';
  TRUECRYPT_VERSIONHINT_21  = 'v2.1';
  TRUECRYPT_VERSIONHINT_21a = 'v2.1a';


procedure TOptionsOTFSystems_F.pbScramDiskBrowseClick(Sender: TObject);
begin
  OpenDialog.title := 'Locate ScramDisk Executable';
  OpenDialog.Filter := FILTER_ONLY_EXE_FILES;
  SDUOpenSaveDialogSetup(OpenDialog, edScramdiskExeLocation.text);
  if (OpenDialog.execute) then
    begin
    edScramdiskExeLocation.text := OpenDialog.Filename;
    end;

end;

procedure TOptionsOTFSystems_F.pbOKClick(Sender: TObject);
begin
  if pbApply.enabled then
    begin
    pbApplyClick(sender);
    end;

  modalresult := mrOK;

end;

procedure TOptionsOTFSystems_F.pbApplyClick(Sender: TObject);
var
  OTFSystemLoop: TOTFESystem;
  tmpSelText: string;
begin
  // Supported OTF systems page...
  for OTFSystemLoop:=low(OTFEUnified.OTFComponents) to high(OTFEUnified.OTFComponents) do
    begin
    STU_INI_FILE.OptOTFCryptoSupport[OTFSystemLoop] := TCheckBox(SDUGetControlWithTag(ord(OTFSystemLoop), pnlEnableSystem)).checked;

    // Activate/deactivate the component
    OTFEUnified.OTFEnabledComponents[OTFSystemLoop] := STU_INI_FILE.OptOTFCryptoSupport[OTFSystemLoop];
    OTFEUnified.OTFComponents[OTFSystemLoop].Active := STU_INI_FILE.OptOTFCryptoSupport[OTFSystemLoop];
    end;

  STU_INI_FILE.OptOTFCryptoDefault := newDefaultOTFSystem;

  STU_INI_FILE.OptOTFE4MSupportScramDisk := (cbScramDiskVolumes.itemindex=1);


  // General page...
  STU_INI_FILE.OptConfirmOnDismount := ckConfirmOnDismount.checked;

  case cbActionOnExit.itemindex of
    1 : STU_INI_FILE.OptOTFOnExit := ExitDismount;
    2 : STU_INI_FILE.OptOTFOnExit := ExitDismountBrutal;
  else
    STU_INI_FILE.OptOTFOnExit := ExitNone;
  end;

  case cbActionOnDblClk.itemindex of
    1 : STU_INI_FILE.OptOTFOnDblClk := DblClkOpenPrompt;
    2 : STU_INI_FILE.OptOTFOnDblClk := DblClkDismountPrompt;
    3 : STU_INI_FILE.OptOTFOnDblClk := DblClkDismount;
    4 : STU_INI_FILE.OptOTFOnDblClk := DblClkDismountBrutal;
    5 : STU_INI_FILE.OptOTFOnDblClk := DblClkOpenPromptDismountPrompt;
    6 : STU_INI_FILE.OptOTFOnDblClk := DblClkOpenPromptDismount;
    7 : STU_INI_FILE.OptOTFOnDblClk := DblClkOpenPromptDismountBrutal;
  else
    STU_INI_FILE.OptOTFOnDblClk := DblClkSlotInfo;
  end;

  STU_INI_FILE.OptOTFExploreAfterMount := ckExploreAfterMount.checked;
  STU_INI_FILE.OptOTFDefaultBrowseDir := edDefaultDir.text;
  STU_INI_FILE.OptOTFDefaultBrowseFilter := cbDefaultFilter.itemindex + 1;
  STU_INI_FILE.OptOTFMountVolStart := ckMountVolStart.checked;
  STU_INI_FILE.OptOTFMountPartStart := ckMountPartStart.checked;
  STU_INI_FILE.OptOTFScramDiskDisableSVLProtection := ckDisableScramDiskSVLProtection.checked;
  STU_INI_FILE.OptOTFAlwaysUnmountedIcon := ckAlwaysUnmounedIcon.checked;
  STU_INI_FILE.OptOTFHidePasswordsEnteredCk := not(ckDisplayHidePasswordsCk.checked);

  // ScramDisk tabsheet...
  STU_INI_FILE.OptOTFScramDiskUseRedScreen := ckScramDiskUseRedScreen.checked;
  STU_INI_FILE.OptOTFScramDiskExe := edScramDiskExeLocation.text;
  STU_INI_FILE.OptOTFScramDiskPrefDrive := cbScramDiskPreferredDrive.items[cbScramDiskPreferredDrive.itemindex][1];

  // CrossCrypt tabsheet...
  STU_INI_FILE.OptOTFCrossCryptExe := edCrossCryptExeLocation.text;

  // E4M tabsheet...
  STU_INI_FILE.OptOTFE4MExe := edE4MExeLocation.text;
  STU_INI_FILE.OptOTFE4MMountDeviceDlg9xStyle := (rgE4MMountDeviceDlgStyle.itemindex=0);

  // FreeOTFE tabsheet...
  STU_INI_FILE.OptOTFFreeOTFEExe := edFreeOTFEExeLocation.text;

  // TrueCrypt tabsheet...
  tmpSelText := cbTrueCryptVersionHint.Items[cbTrueCryptVersionHint.ItemIndex];
  if (tmpSelText = TRUECRYPT_VERSIONHINT_21) then
    begin
    STU_INI_FILE.OptOTFTrueCryptVersionHint := tcv21;
    end
  else if (tmpSelText = TRUECRYPT_VERSIONHINT_21a) then
    begin
    STU_INI_FILE.OptOTFTrueCryptVersionHint := tcv21a;
    end
  else
    begin
    // Fallback to autodetect...
    STU_INI_FILE.OptOTFTrueCryptVersionHint := tcvAuto;
    end;
  STU_INI_FILE.OptOTFTrueCryptMountDeviceDlg9xStyle := (rgTrueCryptMountDeviceDlgStyle.itemindex=0);


  // Pre/post mount executables page
  STU_INI_FILE.OptOTFPostMountExe    := edPostMountExe.text;
  STU_INI_FILE.OptOTFPreDismountExe  := edPreDismountExe.text;
  STU_INI_FILE.OptOTFPostDismountExe := edPostDismountExe.text;
  STU_INI_FILE.OptOTFPrePostWarnNotFound := ckPrePostExeWarn.checked;

  if ( (edPostMountExe.text<>'') and
       ( ((edPostMountExe.text[1]<>'\') and (edPostMountExe.text[1]<>'/')) or
         ((edPostMountExe.text[2]='\') or (edPostMountExe.text[2]='/')) ) )then
    begin
    MessageDlg(
               'Post-mount executable must be located within encrypted '+CRLF+
               'volume.'+CRLF+
               CRLF+
               'Executable specified must be a relative path to the executable '+CRLF+
               'as stored on the volume when mounted',
               mtError,
               [mbOK],
               0
              );
    end;


  if ( (edPreDismountExe.text<>'') and
       ( ((edPreDismountExe.text[1]<>'\') and (edPreDismountExe.text[1]<>'/')) or
         ((edPreDismountExe.text[2]='\') or (edPreDismountExe.text[2]='/')) ) )then
    begin
    MessageDlg(
               'Pre-dismount executable must be located within encrypted '+CRLF+
               'volume.'+CRLF+
               CRLF+
               'Executable specified must be a relative path to the executable '+CRLF+
               'as stored on the volume when mounted',
               mtError,
               [mbOK],
               0
              );
    end;


  // Hotkeys page...
  STU_INI_FILE.OptHKeyVolInfoEnable := ckEnableVolInfo.checked;
  STU_INI_FILE.OptHKeyVolInfoKey    := ShortCutToText(hkVolInfo.hotkey);
  STU_INI_FILE.OptOTFHKeyDismountEnable := ckEnableDismount.checked;
  STU_INI_FILE.OptOTFHKeyDismountBrutalEnable := ckEnableDismountBrutal.checked;
  STU_INI_FILE.OptOTFHKeyDismountKey := ShortCutToText(hkDismount.hotkey);
  STU_INI_FILE.OptOTFHKeyDismountBrutalKey := ShortCutToText(hkDismountBrutal.hotkey);

  // Finish off...
  STU_INI_FILE.WriteIniFile();
  pbApply.enabled := FALSE;

  LoadINIValues();
end;

procedure TOptionsOTFSystems_F.LoadINIValues();
var
  OTFSystemLoop: TOTFESystem;
begin
  STU_INI_FILE.ReadIniFile;

  // Supported OTF systems page...
  for OTFSystemLoop:=low(OTFEUnified.OTFComponents) to high(OTFEUnified.OTFComponents) do
    begin
    TCheckBox(SDUGetControlWithTag(ord(OTFSystemLoop), pnlEnableSystem)).checked := STU_INI_FILE.OptOTFCryptoSupport[OTFSystemLoop];
    end;

  newDefaultOTFSystem := STU_INI_FILE.OptOTFCryptoDefault;

  // ScramDisk = 0
  // E4M = 1
  if STU_INI_FILE.OptOTFE4MSupportScramDisk then
    begin
    cbScramDiskVolumes.itemindex := 1;
    end
  else
    begin
    cbScramDiskVolumes.itemindex := 0;
    end;

  CheckDefaultSystemOK();

  // General page...
  ckConfirmOnDismount.checked := STU_INI_FILE.OptConfirmOnDismount;

  case STU_INI_FILE.OptOTFOnExit of
    ExitDismount       : cbActionOnExit.itemindex := 1;
    ExitDismountBrutal : cbActionOnExit.itemindex := 2;
  else
    cbActionOnExit.itemindex := 0;
  end;

  case STU_INI_FILE.OptOTFOnDblClk of
    DblClkOpenPrompt               : cbActionOnDblClk.itemindex := 1;
    DblClkDismountPrompt           : cbActionOnDblClk.itemindex := 2;
    DblClkDismount                 : cbActionOnDblClk.itemindex := 3;
    DblClkDismountBrutal           : cbActionOnDblClk.itemindex := 4;
    DblClkOpenPromptDismountPrompt : cbActionOnDblClk.itemindex := 5;
    DblClkOpenPromptDismount       : cbActionOnDblClk.itemindex := 6;
    DblClkOpenPromptDismountBrutal : cbActionOnDblClk.itemindex := 7;
  else
    cbActionOnDblClk.itemindex := 0;
  end;

  ckExploreAfterMount.checked := STU_INI_FILE.OptOTFExploreAfterMount;
  edDefaultDir.text := STU_INI_FILE.OptOTFDefaultBrowseDir;
  cbDefaultFilter.itemindex := STU_INI_FILE.OptOTFDefaultBrowseFilter - 1;
  ckMountVolStart.checked := STU_INI_FILE.OptOTFMountVolStart;
  ckMountPartStart.checked := STU_INI_FILE.OptOTFMountPartStart;
  ckDisableScramDiskSVLProtection.checked := STU_INI_FILE.OptOTFScramDiskDisableSVLProtection;
  ckAlwaysUnmounedIcon.checked := STU_INI_FILE.OptOTFAlwaysUnmountedIcon;
  ckDisplayHidePasswordsCk.checked := not(STU_INI_FILE.OptOTFHidePasswordsEnteredCk);

  // ScramDisktabsheet...
  ckScramDiskUseRedScreen.checked := STU_INI_FILE.OptOTFScramDiskUseRedScreen;
  edScramDiskExeLocation.text := STU_INI_FILE.OptOTFScramDiskExe;
  cbScramDiskPreferredDrive.itemindex := cbScramDiskPreferredDrive.items.indexof(STU_INI_FILE.OptOTFScramDiskPrefDrive+':\');

  // CrossCrypt tabsheet...
  edCrossCryptExeLocation.text := STU_INI_FILE.OptOTFCrossCryptExe;

  // E4M tabsheet...
  edE4MExeLocation.text := STU_INI_FILE.OptOTFE4MExe;
  if STU_INI_FILE.OptOTFE4MMountDeviceDlg9xStyle then
    begin
    rgE4MMountDeviceDlgStyle.itemindex:=0;
    end
  else
    begin
    rgE4MMountDeviceDlgStyle.itemindex:=1;
    end;

  // FreeOTFE tabsheet...
  edFreeOTFEExeLocation.text := STU_INI_FILE.OptOTFFreeOTFEExe;

  // TrueCrypt tabsheet...
  case STU_INI_FILE.OptOTFTrueCryptVersionHint of
    tcv21:
      begin
      cbTrueCryptVersionHint.ItemIndex := cbTrueCryptVersionHint.Items.IndexOf(TRUECRYPT_VERSIONHINT_21);
      end;

    tcv21a:
      begin
      cbTrueCryptVersionHint.ItemIndex := cbTrueCryptVersionHint.Items.IndexOf(TRUECRYPT_VERSIONHINT_21a);
      end;
  else
    cbTrueCryptVersionHint.ItemIndex := cbTrueCryptVersionHint.Items.IndexOf(TRUECRYPT_VERSIONHINT_AUTODETECT);
  end;
  if STU_INI_FILE.OptOTFTrueCryptMountDeviceDlg9xStyle then
    begin
    rgTrueCryptMountDeviceDlgStyle.itemindex:=0;
    end
  else
    begin
    rgTrueCryptMountDeviceDlgStyle.itemindex:=1;
    end;


  // Pre/post mount executables page
  edPostMountExe.text    := STU_INI_FILE.OptOTFPostMountExe;
  edPreDismountExe.text  := STU_INI_FILE.OptOTFPreDismountExe;
  edPostDismountExe.text := STU_INI_FILE.OptOTFPostDismountExe;
  ckPrePostExeWarn.checked := STU_INI_FILE.OptOTFPrePostWarnNotFound;

  // Hotkeys page...
  ckEnableVolInfo.checked := STU_INI_FILE.OptHKeyVolInfoEnable;
  hkVolInfo.hotkey        := TextToShortCut(STU_INI_FILE.OptHKeyVolInfoKey);
  ckEnableDismount.checked := STU_INI_FILE.OptOTFHKeyDismountEnable;
  hkDismount.hotkey := TextToShortCut(STU_INI_FILE.OptOTFHKeyDismountKey);
  ckEnableDismountBrutal.checked := STU_INI_FILE.OptOTFHKeyDismountBrutalEnable;
  hkDismountBrutal.hotkey := TextToShortCut(STU_INI_FILE.OptOTFHKeyDismountBrutalKey);

  // Finish off...
  pbApply.enabled := FALSE;
end;

procedure TOptionsOTFSystems_F.SetApplyButton(Sender: TObject);
begin
  EnableDisableAllControls();
  pbApply.enabled := TRUE;

end;

procedure TOptionsOTFSystems_F.FormCreate(Sender: TObject);
begin
  // Do nothing until OTFEUnified is populated - which happens *after* the
  // form is created
end;

procedure TOptionsOTFSystems_F.EnableDisableAllControls();
var
  RunningOnNT: boolean;
  OSversion: DWORD;
begin
  OSversion := GetVersion();
  RunningOnNT := (OSversion<$80000000);

  SDUEnableControl(ckScramDiskUseRedScreen, not(RunningOnNT));

  SDUEnableControl(hkVolInfo, ckEnableVolInfo.checked);
  SDUEnableControl(hkDismount, ckEnableDismount.checked);
  SDUEnableControl(hkDismountBrutal, ckEnableDismountBrutal.checked);

  // If TrueCrypt is installed, check it's version ID and enable/disable the
  // TrueCrypt version option if it's v2.1/v2.1a
  if (OTFEUnified.IsDriverInstalled(otfesTrueCrypt)) then
    begin
    if not(STU_INI_FILE.OptOTFCryptoSupport[otfesTrueCrypt]) then
      begin
      OTFEUnified.OTFComponents[otfesTrueCrypt].Active := TRUE;
      end;

    SDUEnableControl(
                     gbTrueCryptVersionHint,
                     ((OTFEUnified.OTFComponents[otfesTrueCrypt]).Version() = $0210)
                    );

    OTFEUnified.OTFComponents[otfesTrueCrypt].Active := STU_INI_FILE.OptOTFCryptoSupport[otfesTrueCrypt];
    end;

  EnableDisableScramDiskVolumes();
  EnableDisableDefaultSystem();

end;

procedure TOptionsOTFSystems_F.pbForceClearClick(Sender: TObject);
begin
  TOTFEScramDisk(OTFEUnified.OTFComponents[otfesScramDisk]).ClearAllPasswords();

end;

procedure TOptionsOTFSystems_F.pbEnterPasswordClick(Sender: TObject);
begin
  TOTFEScramDisk(OTFEUnified.OTFComponents[otfesScramDisk]).EnterPasswordsDialog();

end;

procedure TOptionsOTFSystems_F.FormShow(Sender: TObject);
var
  c: char;
  currPos: integer;
  currFilterString: string;
  currFilter: string;
begin
  for c:='A' to 'Z' do
    begin
    cbScramDiskPreferredDrive.items.add(c+':\');
    end;

  pcOptions.activepage := tsOTFESupport;

  currFilterString := FILTER_OTFVOLUMEFILES;
  while (Length(currFilterString)>0) do
    begin
    currPos := Pos('|', currFilterString);
    if (currPos>0) then
      begin
      currFilter := Copy(currFilterString, 1, currPos-1);
      cbDefaultFilter.items.add(currFilter);
      delete(currFilterString, 1, currPos);
      currPos := Pos('|', currFilterString);
      if (currPos=0) then
        begin
        currFilterString := '';
        end
      else
        begin
        delete(currFilterString, 1, currPos);
        end;
      end;
    end;


  pnlEnableSystem.bevelouter := bvNone;
  pnlVersions.bevelouter := bvNone;

  cbTrueCryptVersionHint.Items.Clear();
  cbTrueCryptVersionHint.Items.Add(TRUECRYPT_VERSIONHINT_AUTODETECT);
  cbTrueCryptVersionHint.Items.Add(TRUECRYPT_VERSIONHINT_21);
  cbTrueCryptVersionHint.Items.Add(TRUECRYPT_VERSIONHINT_21a);

  SetupOTFSystemDispNameCaptions();
  LoadINIValues();
  CheckOTFComponents();
  EnableDisableAllControls();
  pbApply.Enabled := FALSE;

end;

procedure TOptionsOTFSystems_F.pbDefDirBrowseClick(Sender: TObject);
var
  dir: string;
begin
  Dir := edDefaultDir.text;
  if SelectDirectory(Dir, [sdAllowCreate, sdPerformCreate, sdPrompt],0) then
    begin
    edDefaultDir.text := Dir;
    end;
end;

procedure TOptionsOTFSystems_F.SystemEnabledCheckBoxClick(Sender: TObject);
begin
  pbApply.Enabled := TRUE;
  EnableDisableAllControls();

end;

procedure TOptionsOTFSystems_F.cbDefaultSystemChange(Sender: TObject);
var
  OTFSystemLoop: TOTFESystem;
begin
  newDefaultOTFSystem := otfesScramDisk;

  for OTFSystemLoop:=low(OTFEUnified.OTFComponents) to high(OTFEUnified.OTFComponents) do
    begin
    if cbDefaultSystem.text = OTFESDispNames[OTFSystemLoop] then
      begin
      newDefaultOTFSystem := OTFSystemLoop;
      pbApply.Enabled := TRUE;
      end;
    end;

end;

procedure TOptionsOTFSystems_F.EnableDisableScramDiskVolumes();
var
  chkdScramDisk: boolean;
  chkdE4M: boolean;
  E4MsupportsSD: boolean;
begin
  chkdScramDisk:= (TCheckBox(SDUGetControlWithTag(ord(otfesScramDisk), pnlEnableSystem))).checked;
  chkdE4M      := (TCheckBox(SDUGetControlWithTag(ord(otfesE4M), pnlEnableSystem))).checked;

  E4MsupportsSD := FALSE;
  if OTFEUnified<>nil then
    begin
    if OTFEUnified.OTFEnabledComponents[otfesE4M] then
      begin
      E4MsupportsSD := TOTFEE4M(OTFEUnified.OTFComponents[otfesE4M]).VersionCanSupportScramDiskVols();
      end;
    end;

  SDUEnableControl(lblScramDiskVolumes, (chkdScramDisk AND chkdE4M AND E4MsupportsSD));
  SDUEnableControl(cbScramDiskVolumes, (chkdScramDisk AND chkdE4M AND E4MsupportsSD));

  // ScramDisk = 0
  // E4M = 1
  if (not(chkdScramDisk) AND (chkdE4M AND E4MsupportsSD)) then
    begin
    cbScramDiskVolumes.itemindex := 1;
    end
  else
    begin
    cbScramDiskVolumes.itemindex := 0;
    end;

end;

procedure TOptionsOTFSystems_F.EnableDisableDefaultSystem();
begin
  CheckDefaultSystemOK();

end;

procedure TOptionsOTFSystems_F.CheckOTFComponents();
const
  STR_NOT_DETECTED = 'not detected';
var
  currSystemInstalled: boolean;
  OTFSystemLoop: TOTFESystem;
  loopOrd: integer;
  strOTFEVersion: string;
begin
  for OTFSystemLoop:=low(OTFEUnified.OTFComponents) to high(OTFEUnified.OTFComponents) do
    begin
    loopOrd:= ord(OTFSystemLoop);
    currSystemInstalled := OTFEUnified.IsDriverInstalled(OTFSystemLoop);

    if currSystemInstalled then
      begin
      if not(STU_INI_FILE.OptOTFCryptoSupport[OTFSystemLoop]) then
        begin
        OTFEUnified.OTFComponents[OTFSystemLoop].Active := TRUE;
        end;

      strOTFEVersion := OTFEUnified.OTFComponents[OTFSystemLoop].VersionStr();
      if strOTFEVersion='' then
        begin
        strOTFEVersion := '(Unknown)';
        end;
      TLabel(SDUGetControlWithTag(loopOrd, pnlVersions)).caption := strOTFEVersion;

      OTFEUnified.OTFComponents[OTFSystemLoop].Active := STU_INI_FILE.OptOTFCryptoSupport[OTFSystemLoop];
      end
    else
      begin
      TLabel(SDUGetControlWithTag(loopOrd, pnlVersions)).caption := STR_NOT_DETECTED;
      TCheckBox(SDUGetControlWithTag(loopOrd, pnlEnableSystem)).checked := FALSE;
      end;

    SDUEnableControl(SDUGetControlWithTag(loopOrd, pnlVersions), currSystemInstalled);
    SDUEnableControl(SDUGetControlWithTag(loopOrd, pnlEnableSystem), currSystemInstalled);
    end;

  tsOTFECrossCrypt.tabvisible := OTFEUnified.IsDriverInstalled(otfesCrossCrypt);
  tsOTFEE4M.tabvisible        := OTFEUnified.IsDriverInstalled(otfesE4M);
  tsOTFEFreeOTFE.tabvisible   := OTFEUnified.IsDriverInstalled(otfesFreeOTFE);
  tsOTFEScramDisk.tabvisible  := OTFEUnified.IsDriverInstalled(otfesScramDisk);
  tsOTFETrueCrypt.tabvisible  := OTFEUnified.IsDriverInstalled(otfesTrueCrypt);

  EnableDisableAllControls();

end;

procedure TOptionsOTFSystems_F.SetupOTFSystemDispNameCaptions();
var
  OTFSystemLoop: TOTFESystem;
begin
  for OTFSystemLoop:=low(OTFEUnified.OTFComponents) to high(OTFEUnified.OTFComponents) do
    begin
    (TCheckBox(SDUGetControlWithTag(ord(OTFSystemLoop), pnlEnableSystem))).caption := OTFESDispNames[OTFSystemLoop];
    end;

end;

procedure TOptionsOTFSystems_F.CheckDefaultSystemOK();
var
  OTFSystemLoop: TOTFESystem;
begin
  cbDefaultSystem.items.clear();

  for OTFSystemLoop:=low(OTFEUnified.OTFComponents) to high(OTFEUnified.OTFComponents) do
    begin
    if (TCheckBox(SDUGetControlWithTag(ord(OTFSystemLoop), pnlEnableSystem)).checked) then
      begin
      cbDefaultSystem.items.add(OTFESDispNames[OTFSystemLoop]);
      end;
    end;

  SDUEnableControl(cbDefaultSystem, (cbDefaultSystem.items.count>1));
  SDUEnableControl(lblDefaultSystem, (cbDefaultSystem.items.count>1));

  if cbDefaultSystem.items.count=1 then
    begin
    // if there is only one OTF system enabled, then there's only one that can
    // be selected as the default system; select it.
    cbDefaultSystem.itemindex := 0;
    end
  else if cbDefaultSystem.items.count<1 then
    begin
    // if there is are no OTF systems enabled, then set the default system to
    // ScramDisk
    newDefaultOTFSystem := otfesScramDisk;
    end
  else
    begin
    // OK, if we get to here then the user has a choice of default systems; set
    // the selected one to "newDefaultOTFSystem", or the first item in the
    // list if this can't be found.
    // ScramDisk
    if cbDefaultSystem.items.indexof(OTFESDispNames[newDefaultOTFSystem])>-1 then
      begin
      cbDefaultSystem.itemindex := cbDefaultSystem.items.indexof(OTFESDispNames[newDefaultOTFSystem]);
      end
    else
      begin
      cbDefaultSystem.itemindex := 0;
      end;
    end;

  // Update the tag to ensure that it is the correct one
  cbDefaultSystemChange(nil);

end;

procedure TOptionsOTFSystems_F.pbE4MBrowseClick(Sender: TObject);
begin
  OpenDialog.title := 'Locate E4M Executable';
  OpenDialog.Filter := FILTER_ONLY_EXE_FILES;
  SDUOpenSaveDialogSetup(OpenDialog, edE4MExeLocation.text);
  if (OpenDialog.execute) then
    begin
    edE4MExeLocation.text := OpenDialog.Filename;
    end;

end;

procedure TOptionsOTFSystems_F.pbPrePostBrowse1Click(Sender: TObject);
begin
  OpenDialog.title := 'Locate post mount executable';
  OpenDialog.Filter := FILTER_EXECUTABLE_FILES;
  SDUOpenSaveDialogSetup(OpenDialog, edPostMountExe.text);
  if (OpenDialog.execute) then
    begin
    edPostMountExe.text := copy(OpenDialog.Filename, 3, length(OpenDialog.Filename)-2);
    end;

end;

procedure TOptionsOTFSystems_F.pbPrePostBrowse2Click(Sender: TObject);
begin
  OpenDialog.title := 'Locate pre dismount executable';
  OpenDialog.Filter := FILTER_EXECUTABLE_FILES;
  SDUOpenSaveDialogSetup(OpenDialog, edPreDismountExe.text);
  if (OpenDialog.execute) then
    begin
    edPreDismountExe.text := copy(OpenDialog.Filename, 3, length(OpenDialog.Filename)-2);
    end;

end;

procedure TOptionsOTFSystems_F.pbPrePostBrowse3Click(Sender: TObject);
begin
  OpenDialog.title := 'Locate post dismount executable';
  OpenDialog.Filter := FILTER_EXECUTABLE_FILES;
  SDUOpenSaveDialogSetup(OpenDialog, edPostDismountExe.text);
  if (OpenDialog.execute) then
    begin
    edPostDismountExe.text := OpenDialog.Filename;
    end;

end;

procedure TOptionsOTFSystems_F.pbCrossCryptBrowseClick(Sender: TObject);
begin
  OpenDialog.title := 'Locate CrossCrypt Executable';
  OpenDialog.Filter := FILTER_ONLY_EXE_FILES;
  SDUOpenSaveDialogSetup(OpenDialog, edCrossCryptExeLocation.text);
  if (OpenDialog.execute) then
    begin
    edCrossCryptExeLocation.text := OpenDialog.Filename;
    end;

end;

procedure TOptionsOTFSystems_F.pbFreeOTFEBrowseClick(Sender: TObject);
begin
  OpenDialog.title := 'Locate FreeOTFE Executable';
  OpenDialog.Filter := FILTER_ONLY_EXE_FILES;
  SDUOpenSaveDialogSetup(OpenDialog, edFreeOTFEExeLocation.text);
  if (OpenDialog.execute) then
    begin
    edFreeOTFEExeLocation.text := OpenDialog.Filename;
    end;

end;


// -----------------------------------------------------------------------------

// -----------------------------------------------------------------------------
// -----------------------------------------------------------------------------
{$WARN UNIT_PLATFORM ON}
// -----------------------------------------------------------------------------

END.

