unit RegKeyEntry_U;
// Description: Registry Key Add/Edit Dialog
// By Sarah Dean
// Email: sdean12@softhome.net
// WWW:   http://www.SDean12.org/
//
// -----------------------------------------------------------------------------
//


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TRegKeyEntry_F = class(TForm)
    rgRoot: TRadioGroup;
    edRegPath: TEdit;
    Label1: TLabel;
    pbOK: TButton;
    pbCancel: TButton;
    Label2: TLabel;
    Label6: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label7: TLabel;
    procedure pbOKClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    RegistryKey: string;
  end;

var
  RegKeyEntry_F: TRegKeyEntry_F;

implementation

{$R *.DFM}

uses AppGlobal_U, SDUGeneral;

procedure TRegKeyEntry_F.pbOKClick(Sender: TObject);
var
  keyRoot: string;
  enteredText: string;
  userSuppliedRoot: boolean;
begin
  userSuppliedRoot := FALSE;

  case rgRoot.ItemIndex of
  0: RegistryKey := 'HKCR';
  1: RegistryKey := 'HKCU';
  2: RegistryKey := 'HKLM';
  3: RegistryKey := 'HKU ';
  4: RegistryKey := 'HKCC';
  5: RegistryKey := 'HKDD';
  else
    RegistryKey := '';
  end;

  keyRoot := '';
  enteredText := trim(edRegPath.text);
  if (pos('[', enteredText)=1) AND
     (pos(']', enteredText)=length(enteredText)) then
    begin
    Delete(enteredText, 1, 1);
    Delete(enteredText, length(enteredText), 1);
    end;

  if Pos('\', enteredText)>0 then
    begin
    keyRoot := Copy(enteredText, 1, Pos('\', enteredText)-1);
    Delete(enteredText, 1, length(keyRoot)+1);
    end;

  if keyRoot='HKEY_CLASSES_ROOT' then
    begin
    RegistryKey := 'HKCR';
    userSuppliedRoot := TRUE;
    end
  else if keyRoot='HKEY_CURRENT_USER' then
    begin
    RegistryKey := 'HKCU';
    userSuppliedRoot := TRUE;
    end
  else if keyRoot='HKEY_LOCAL_MACHINE' then
    begin
    RegistryKey := 'HKLM';
    userSuppliedRoot := TRUE;
    end
  else if keyRoot='HKEY_USERS' then
    begin
    RegistryKey := 'HKU ';
    userSuppliedRoot := TRUE;
    end
  else if keyRoot='HKEY_CURRENT_CONFIG' then
    begin
    RegistryKey := 'HKCC';
    userSuppliedRoot := TRUE;
    end
  else if keyRoot='HKEY_DYN_DATA' then
    begin
    RegistryKey := 'HKDD';
    userSuppliedRoot := TRUE;
    end;

  if userSuppliedRoot then
    begin
    edRegPath.text := enteredText;
    end;

  if pos('\', edRegPath.text)<>1 then
    begin
    RegistryKey := RegistryKey + '\';
    end;
  RegistryKey := RegistryKey + edRegPath.text;

  ModalResult := mrOK;
end;

procedure TRegKeyEntry_F.FormShow(Sender: TObject);
begin
  if Pos('HKCR', RegistryKey)=1 then
    begin
    rgRoot.ItemIndex := 0;
    end
  else if Pos('HKCU', RegistryKey)=1 then
    begin
    rgRoot.ItemIndex := 1;
    end
  else if Pos('HKLM', RegistryKey)=1 then
    begin
    rgRoot.ItemIndex := 2;
    end
  else if Pos('HKU ', RegistryKey)=1 then
    begin
    rgRoot.ItemIndex := 3;
    end
  else if Pos('HKCC', RegistryKey)=1 then
    begin
    rgRoot.ItemIndex := 4;
    end
  else if Pos('HKDD', RegistryKey)=1 then
    begin
    rgRoot.ItemIndex := 5;
    end;

  Delete(RegistryKey, 1, 5);

  edRegPath.text := RegistryKey;

end;

END.

