program SecureTrayUtil;

uses
  Forms,
  SysUtils,
  Windows,
  SDUGeneral,
  Main_U in 'Main_U.pas' {Main_F},
  AppGlobal_U in '..\Common\AppGlobal_U.pas',
  About_U in 'About_U.pas' {About_F},
  STUIniFile_U in '..\Common\STUIniFile_U.pas',
  OptionsGeneral_U in 'OptionsGeneral_U.pas' {OptionsGeneral_F},
  OptionsOTFSystems_U in 'OptionsOTFSystems_U.pas' {OptionsOTFSystems_F},
  OptionsSelfD_U in 'OptionsSelfD_U.pas' {OptionsSelfD_F},
  RegKeyEntry_U in 'RegKeyEntry_U.pas' {RegKeyEntry_F},
  TargetTypeSelect_U in 'TargetTypeSelect_U.pas' {TargetTypeSelect_F},
  ConfigShredderInt_U in 'ConfigShredderInt_U.pas' {ConfigShredderInt_F},
  ConfigShredderExt_U in 'ConfigShredderExt_U.pas' {ConfigShredderExt_F},
  STUIniFileConsts_U in '..\Common\STUIniFileConsts_U.pas',
  ShortCut in 'ShortCut.pas',
  DriveSelect_U in 'DriveSelect_U.pas' {DriveSelect_F},
  TriggerConfig_U in 'TriggerConfig_U.pas' {TriggerConfig_F},
  COMPort_U in 'COMPort_U.pas',
  TouchFileSelect_U in 'TouchFileSelect_U.pas' {TouchFileSelect_F},
  AppGlobalConsts_U in '..\Common\AppGlobalConsts_U.pas',
  DismountVolumes_U in 'DismountVolumes_U.pas' {DismountVolumes_F},
  VolumeInfo_U in 'VolumeInfo_U.pas' {VolumeInfo_F},
  OTFVolumeDetailsCrossCrypt_U in 'OTFVolumeDetailsCrossCrypt_U.pas' {OTFVolumeDetailsCrossCrypt_F},
  OTFVolumeDetails_U in 'OTFVolumeDetails_U.pas' {OTFVolumeDetails_F},
  OTFVolumeDetailsScramDisk_U in 'OTFVolumeDetailsScramDisk_U.pas' {OTFVolumeDetailsScramDisk_F},
  OTFVolumeDetailsPGPDisk_U in 'OTFVolumeDetailsPGPDisk_U.pas' {OTFVolumeDetailsPGPDisk_F},
  OTFVolumeDetailsBestCrypt_U in 'OTFVolumeDetailsBestCrypt_U.pas' {OTFVolumeDetailsBestCrypt_F},
  CalculateFileHash_U in 'CalculateFileHash_U.pas' {CalculateFileHash_F},
  IconChooser_U in 'IconChooser_U.pas' {IconChooser_F},
  OTFVolumeDetailsFreeOTFE_U in 'OTFVolumeDetailsFreeOTFE_U.pas' {OTFVolumeDetailsFreeOTFE_F},
  OTFVolumeDetailsTrueCrypt_U in 'OTFVolumeDetailsTrueCrypt_U.pas' {OTFVolumeDetailsTrueCrypt_F},
  WinInfo in 'WinInfo.pas',
  OTFVolumeDetailsE4M_U in 'OTFVolumeDetailsE4M_U.pas' {OTFVolumeDetailsE4M_F};

{$R *.RES}

var
  Main_F: TMain_F;
  otherRunningAppWindow: THandle;

begin
  Application.Title := 'SecureTrayUtil';
  Application.Initialize;
  // CreateForm also checks and performs any command line options
  Application.CreateForm(TMain_F, Main_F);
  Main_F.visible := FALSE;
  Application.ShowMainForm := FALSE;
  otherRunningAppWindow := SDUDetectExistingApp();


  // If we were called and the "StayLoaded" is set, then
  //   if no running app was found then
  //     we continue to run the main app
  //   else
  //     we quit (already loaded)
  // else
  //   if we were called with no command line arguments then
  //     if no running app was found then
  //       we continue to run the main app
  //     else
  //       we raise the previous application to the top
  //   else
  //     quit (ran with command line arguments)

  // If we were called and the "StayLoaded" is set, then
  if Main_F.StayLoaded then
    begin
  //   if no running app was found then
    if otherRunningAppWindow=0 then
      begin
  //     we run continue to the main app
      Main_F.InitApp();
      Application.Run;
      end
  //   else
    else
      begin
  //     we quit (already loaded)
      // (i.e. do nothing)
      end;
    end
  // else
  else
    begin
  //   if we were called with no command line arguments then
    if (not(Main_F.CommandLineOnly)) then
      begin
  //     if no running app was found then
      if otherRunningAppWindow=0 then
        begin
  //       we continue to run the main app
        Main_F.InitApp();
        Application.Run;
        end
  //     else
      else
        begin
  //       we raise the previous application to the top
        SetForegroundWindow(otherRunningAppWindow);
        end;
      end
  //   else
    else
      begin
  //     quit (ran with command line arguments)
      // (i.e. do nothing)
      end;
    end;


END.


